<?php

declare(strict_types=1);
namespace FiloBlu\AdyenPaymentLinkGenerator\Block\Adminhtml\Order\Create\Search\Grid\DataProvider;

use FiloBlu\AdyenPaymentLinkGenerator\Helper\Data;
use Magento\Catalog\Model\Product\Attribute\Source\Status;
use Magento\Catalog\Model\ResourceModel\Product\CollectionFactory as ProductCollectionFactory;
use Magento\Catalog\Model\ResourceModel\Product\Collection;
use Magento\Store\Model\Store;

/**
 *
 */
class ProductCollection extends \Magento\Sales\Block\Adminhtml\Order\Create\Search\Grid\DataProvider\ProductCollection
{
    /**
     * @var Data
     */
    protected $helper;

    public function __construct(
        ProductCollectionFactory $collectionFactory,
        Data $helper
    )
    {
        $this->helper = $helper;
        parent::__construct($collectionFactory);
    }

    /**
     * @param \Magento\Store\Model\Store $store
     * @return \Magento\Catalog\Model\ResourceModel\Product\Collection
     */
    public function getCollectionForStore(Store $store): Collection
    {
        $collection = parent::getCollectionForStore($store);

        if (!$this->helper->filterEnableProductInBEOrderGrid()) {
            return $collection;
        }

        $collection->addAttributeToFilter('status', Status::STATUS_ENABLED);
        return $collection;
    }
}
