<?php

namespace FiloBlu\AdyenPaymentLinkGenerator\Plugin\Gateway\Request;

use Adyen\Payment\Gateway\Request\PaymentDataBuilder;
use Adyen\Payment\Helper\PaymentMethods;
use FiloBlu\AdyenPaymentLinkGenerator\Helper\Data;
use Magento\Payment\Gateway\Helper\SubjectReader;

class PaymentDataBuilderPlugin
{
    /**
     * @var Data
     */
    private $helper;

    public function __construct(Data $helper)
    {
        $this->helper = $helper;
    }

    /**
     * @param PaymentDataBuilder $paymentDataBuilder
     * @param $result
     * @param array $buildSubject
     * @return array
     */
    public function afterBuild(PaymentDataBuilder $paymentDataBuilder, $result, array $buildSubject)
    {
        $paymentDataObject = SubjectReader::readPayment($buildSubject);

        if ($paymentDataObject->getPayment()->getMethodInstance()->getCode() == PaymentMethods::ADYEN_PAY_BY_LINK)
        {
            $hppNotAllowed = $this->helper->getAdyenPBLOrdersHppNotAllowed();

            if (!empty($hppNotAllowed)) {
                $result['body']['blockedPaymentMethods'] = $hppNotAllowed;
            }
        }

        return $result;
    }
}
